import type { Metadata } from 'next'
import './globals.css'

export const metadata: Metadata = {
  title: 'CVE-2025-29927 | Next.js Middleware Bypass POC',
  description: 'CVE-2025-29927 | Next.js Middleware Bypass POC',
}

export default function RootLayout({
  children,
}: {
  children: React.ReactNode
}) {
  return (
    <html lang="en">
      <body>
        <div className="container">
          <header className="site-header">
            <h1 className="site-title">CVE-2025-29927</h1>
            <nav className="nav">
              <ul className="nav-list">
                <li><a href="/" className="nav-link">Home (Public)</a></li>
                <li><a href="/dashboard" className="nav-link">Dashboard (Protected)</a></li>
              </ul>
            </nav>
          </header>
          {children}
        </div>
      </body>
    </html>
  )
} 