export default function Home() {
  return (
    <main>
      <section className="content-section">
        <h1 className="page-title">Middleware Next.js Vulnerability</h1>
        <p className="page-description">
          Technical demonstration of the CVE-2025-29927 vulnerability allowing bypassing security checks in Next.js middlewares.
        </p>
        
        <div className="card">
          <h2 className="card-title">Description</h2>
          <p className="card-text">
            The CVE-2025-29927 vulnerability allows an attacker to bypass authentication 
            and authorization checks implemented in Next.js middleware. 
            This bypass is possible by exploiting the internal header 
            <span className="inline-code">x-middleware-subrequest</span>.
          </p>
        </div>

        <div className="card">
          <h2 className="card-title">Testing the Vulnerability</h2>
          <p className="card-text">
            This application contains protected routes that normally require 
            authentication. This application is vulnerable to the CVE-2025-29927 vulnerability.
          </p>
          
          <h3 className="card-title">To exploit the vulnerability:</h3>
          <pre className="code-block">
{`npm run exploit http://localhost:3000/dashboard`}
          </pre>
        </div>
      </section>

      <footer className="site-footer">
        <p className="footer-text">
          Technical demonstration of the CVE-2025-29927 vulnerability by <a href="https://github.com/kOaDT">kOaDT</a>
        </p>
      </footer>
    </main>
  );
} 